"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEnum = exports.useArray = exports.use = void 0;
function use(constructor) {
    // @ts-expect-error typescript struggle
    var ctoschema = constructor;
    if (ctoschema === undefined) {
        throw new Error("undefined schema for " + constructor);
    }
    if (ctoschema === String) {
        return { type: "string" };
    }
    if (ctoschema === Number) {
        return { type: "number" };
    }
    if (ctoschema === Boolean) {
        return { type: "boolean" };
    }
    if (ctoschema === null) {
        return { type: "null" };
    }
    if ("__schema" in ctoschema === false) {
        throw new TypeError(ctoschema.name + ": not a schema class");
    }
    return JSON.parse(JSON.stringify(ctoschema.__schema));
}
exports.use = use;
function useArray(constructor) {
    var ctoschema = constructor;
    // @ts-expect-error typescript struggle
    if ([String, Number, Boolean, null].includes(constructor)) {
        return {
            type: "array",
            items: use(constructor),
        };
    }
    if ("__schema" in ctoschema === false) {
        throw new TypeError(constructor + ": not a schema class");
    }
    return {
        type: "array",
        items: JSON.parse(JSON.stringify(ctoschema.__schema)),
    };
}
exports.useArray = useArray;
function useEnum(values) {
    return { enum: __spreadArray([], __read(values)) };
}
exports.useEnum = useEnum;
//# sourceMappingURL=use.js.map